<!DOCTYPE html><html lang="en"><head><meta charset="utf-8"><meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui"><title>JavaScript: Programové struktury</title><meta name="author" content="Ing. Jan Kolomazník, Ph.D. &lt;jan.kolomaznik@gmail.com&gt;"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reset.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/reveal.css"><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/theme/serif.css" id="theme"><!--This CSS is generated by the Asciidoctor reveal.js converter to further integrate AsciiDoc's existing semantic with reveal.js--><style type="text/css">.reveal div.right{float:right}

/* listing block */
.reveal .listingblock.stretch>.content{height: 100%}
.reveal .listingblock.stretch>.content>pre{height: 100%}
.reveal .listingblock.stretch>.content>pre>code{height:100%;max-height:100%}

/* tables */
table{border-collapse:collapse;border-spacing:0}
table{margin-bottom:1.25em;border:solid 1px #dedede}
table thead tr th,table thead tr td,table tfoot tr th,table tfoot tr td{padding:.5em .625em .625em;font-size:inherit;text-align:left}
table tr th,table tr td{padding:.5625em .625em;font-size:inherit}
table thead tr th,table tfoot tr th,table tbody tr td,table tr td,table tfoot tr td{display:table-cell;line-height:1.6}
td.tableblock>.content{margin-bottom:1.25em}
td.tableblock>.content>:last-child{margin-bottom:-1.25em}
table.tableblock,th.tableblock,td.tableblock{border:0 solid #dedede}
table.grid-all>thead>tr>.tableblock,table.grid-all>tbody>tr>.tableblock{border-width:0 1px 1px 0}
table.grid-all>tfoot>tr>.tableblock{border-width:1px 1px 0 0}
table.grid-cols>*>tr>.tableblock{border-width:0 1px 0 0}
table.grid-rows>thead>tr>.tableblock,table.grid-rows>tbody>tr>.tableblock{border-width:0 0 1px}
table.grid-rows>tfoot>tr>.tableblock{border-width:1px 0 0}
table.grid-all>*>tr>.tableblock:last-child,table.grid-cols>*>tr>.tableblock:last-child{border-right-width:0}
table.grid-all>tbody>tr:last-child>.tableblock,table.grid-all>thead:last-child>tr>.tableblock,table.grid-rows>tbody>tr:last-child>.tableblock,table.grid-rows>thead:last-child>tr>.tableblock{border-bottom-width:0}
table.frame-all{border-width:1px}
table.frame-sides{border-width:0 1px}
table.frame-topbot,table.frame-ends{border-width:1px 0}
.reveal table th.halign-left,.reveal table td.halign-left{text-align:left}
.reveal table th.halign-right,.reveal table td.halign-right{text-align:right}
.reveal table th.halign-center,.reveal table td.halign-center{text-align:center}
.reveal table th.valign-top,.reveal table td.valign-top{vertical-align:top}
.reveal table th.valign-bottom,.reveal table td.valign-bottom{vertical-align:bottom}
.reveal table th.valign-middle,.reveal table td.valign-middle{vertical-align:middle}
table thead th,table tfoot th{font-weight:bold}
tbody tr th{display:table-cell;line-height:1.6}
tbody tr th,tbody tr th p,tfoot tr th,tfoot tr th p{font-weight:bold}
thead{display:table-header-group}

.reveal table.grid-none th,.reveal table.grid-none td{border-bottom:0!important}

/* kbd macro */
kbd{font-family:"Droid Sans Mono","DejaVu Sans Mono",monospace;display:inline-block;color:rgba(0,0,0,.8);font-size:.65em;line-height:1.45;background:#f7f7f7;border:1px solid #ccc;-webkit-border-radius:3px;border-radius:3px;-webkit-box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em white inset;box-shadow:0 1px 0 rgba(0,0,0,.2),0 0 0 .1em #fff inset;margin:0 .15em;padding:.2em .5em;vertical-align:middle;position:relative;top:-.1em;white-space:nowrap}
.keyseq kbd:first-child{margin-left:0}
.keyseq kbd:last-child{margin-right:0}

/* callouts */
.conum[data-value] {display:inline-block;color:#fff!important;background:rgba(0,0,0,.8);-webkit-border-radius:50%;border-radius:50%;text-align:center;font-size:.75em;width:1.67em;height:1.67em;line-height:1.67em;font-family:"Open Sans","DejaVu Sans",sans-serif;font-style:normal;font-weight:bold}
.conum[data-value] *{color:#fff!important}
.conum[data-value]+b{display:none}
.conum[data-value]:after{content:attr(data-value)}
pre .conum[data-value]{position:relative;top:-.125em}
b.conum *{color:inherit!important}
.conum:not([data-value]):empty{display:none}
/* Callout list */
.hdlist>table,.colist>table{border:0;background:none}
.hdlist>table>tbody>tr,.colist>table>tbody>tr{background:none}
td.hdlist1,td.hdlist2{vertical-align:top;padding:0 .625em}
td.hdlist1{font-weight:bold;padding-bottom:1.25em}
/* Disabled from Asciidoctor CSS because it caused callout list to go under the
 * source listing when .stretch is applied (see #335)
 * .literalblock+.colist,.listingblock+.colist{margin-top:-.5em} */
.colist td:not([class]):first-child{padding:.4em .75em 0;line-height:1;vertical-align:top}
.colist td:not([class]):first-child img{max-width:none}
.colist td:not([class]):last-child{padding:.25em 0}

/* Override Asciidoctor CSS that causes issues with reveal.js features */
.reveal .hljs table{border: 0}
/* Callout list rows would have a bottom border with some reveal.js themes (see #335) */
.reveal .colist>table th, .reveal .colist>table td {border-bottom:0}
/* Fixes line height with Highlight.js source listing when linenums enabled (see #331) */
.reveal .hljs table thead tr th, .reveal .hljs table tfoot tr th, .reveal .hljs table tbody tr td, .reveal .hljs table tr td, .reveal .hljs table tfoot tr td{line-height:inherit}

/* Columns layout */
.columns .slide-content {
  display: flex;
}

.columns.wrap .slide-content {
  flex-wrap: wrap;
}

.columns.is-vcentered .slide-content {
  align-items: center;
}

.columns .slide-content > .column {
  display: block;
  flex-basis: 0;
  flex-grow: 1;
  flex-shrink: 1;
  padding: .75rem;
}

.columns .slide-content > .column.is-full {
  flex: none;
  width: 100%;
}

.columns .slide-content > .column.is-four-fifths {
  flex: none;
  width: 80%;
}

.columns .slide-content > .column.is-three-quarters {
  flex: none;
  width: 75%;
}

.columns .slide-content > .column.is-two-thirds {
  flex: none;
  width: 66.6666%;
}

.columns .slide-content > .column.is-three-fifths {
  flex: none;
  width: 60%;
}

.columns .slide-content > .column.is-half {
  flex: none;
  width: 50%;
}

.columns .slide-content > .column.is-two-fifths {
  flex: none;
  width: 40%;
}

.columns .slide-content > .column.is-one-third {
  flex: none;
  width: 33.3333%;
}

.columns .slide-content > .column.is-one-quarter {
  flex: none;
  width: 25%;
}

.columns .slide-content > .column.is-one-fifth {
  flex: none;
  width: 20%;
}
</style><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/all.min.css"><link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.12.0-1/css/v4-shims.min.css"><!--Printing and PDF exports--><script>var link = document.createElement( 'link' );
link.rel = 'stylesheet';
link.type = 'text/css';
link.href = window.location.search.match( /print-pdf/gi ) ? "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/pdf.css" : "https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/css/print/paper.css";
document.getElementsByTagName( 'head' )[0].appendChild( link );</script></head><body><div class="reveal"><div class="slides"><section class="title" data-state="title"><h1>JavaScript</h1><h2>Programové struktury</h2><div class="preamble"><div class="paragraph"><p><a href="https://eloquentjavascript.net/02_program_structure.html" class="bare">https://eloquentjavascript.net/02_program_structure.html</a></p></div></div><p class="author"><small>Ing. Jan Kolomazník, Ph.D. &lt;jan.kolomaznik@gmail.com&gt;</small></p></section>
<section><section id="_výraz"><h2>Výraz</h2><div class="slide-content"><div class="paragraph"><p>Nebo také příkaz je kus kódu, který provádí operaci nebo vytváří hodnotu</p></div><div class="ulist"><ul><li><p>V JS je <strong>slušností</strong> psát po výrazu <code>;</code> ale nemusí se to</p></li><li><p>Pokud je vynecháte, pak se za další příkaz považuje kód na dalším řádku.</p></li></ul></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">1;
!false;</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Pokud kromě hodnoty příkaz mění "něco" uvnitř aplikace, říkáme tomu <code>side effect</code>.</p></div>
<div class="paragraph"><p>Příkladem je výpis na konzoli, ten nic nevrací ale mění stav.</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log("Hello world");</code></pre></div></div></div></section></section>
<section><section id="_přiřazení"><h2>Přiřazení</h2><div class="slide-content"><div class="paragraph"><p>Doposud jsme vytvořili hodnoty, pojďme je ale někam uložit, abychom je mohli použít někdy později.</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let caught = 5 * 5;</code></pre></div></div><div class="ulist"><ul><li><p>Klíčové slovo <code>let</code> a musí být následované jménem nevo proměnné.</p></li><li><p>Proměnnou je pak možné použít použitím jejího jména</p></li></ul></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let ten = 10;
console.log(ten * ten);
// → 100</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Jméno (proměnná) jení s hodnotou svázána již navždy, její hodnotu je možné měnit</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let mood = "light";
console.log(mood);
// → light
mood = "dark";
console.log(mood);
// → dark</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Proměnná je takový box uchovávající hodnotu, program ale pracuje s hodnotami</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let luigisDebt = 140;
luigisDebt = luigisDebt - 35;
console.log(luigisDebt);
// → 105</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>V rámci jednoho výrazu můžeme přiřadit více hodnot do více proměnných</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let one = 1, two = 2;
console.log(one + two);
// → 3</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Další klíčová slova jsou <code>var</code> a <code>const</code></p><div class="ulist"><ul><li><p><code>const</code> definuje konstantu, proměnnou jejich hodnotu nelze měnit</p></li><li><p><code>var</code> značí <em>variable</em> a roku 2015 bylo nahrazení právě slovem <code>let</code>.
Detaily mezi <code>let</code> a <code>var</code> probereme za chvíli.</p></li></ul></div></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">var name = "Ayda";
const greeting = "Hello ";
console.log(greeting + name);
// → Hello Ayda</code></pre></div></div></div></section><section id="_jména_proměnných"><h2>Jména proměnných</h2><div class="slide-content"><div class="paragraph"><p>Pro jména proměnných následuje několik pravidel</p></div>
<div class="ulist"><ul><li><p>Skládají se z pismen, čísel, $ a _ a nesmí začínat číslem</p></li><li><p>rozlišují se velká a malá písmena, používá se <a href="https://cs.wikipedia.org/wiki/CamelCase">camelCase</a>.</p></li><li><p>Nesmí to být klíčové slovo: <code>breakcase</code>, <code>catch</code>, <code>class</code>, <code>const</code>, <code>continue</code>, <code>debugger</code>, <code>default</code>, <code>delete</code>, <code>do</code>, <code>else</code>, <code>enum</code>, <code>export</code>, <code>extends</code>, <code>false</code>, <code>finally</code>, <code>for</code>, <code>function</code>, <code>if</code>, <code>implements</code>, <code>import</code>, <code>interface</code>, <code>in</code>, <code>instanceof</code>, <code>let</code>, <code>new</code>, <code>package</code>, <code>private</code>, <code>protected</code>, <code>public</code>, <code>return</code>, <code>static</code>, <code>super</code>, <code>switch</code>, <code>this</code>, <code>throw</code>, <code>true</code>, <code>try</code>, <code>typeof</code>, <code>var</code>, <code>void</code>, <code>while</code>, <code>with</code>, <code>yield</code></p></li></ul></div></div></section></section>
<section><section id="_prostředí"><h2>Prostředí</h2><div class="slide-content"><div class="paragraph"><p>Prostředím se myslím kolekce všech proměnných a jejich hodnot.</p></div><div class="ulist"><ul><li><p>Při startu programu není prázdné a obsahuje již nějaké proměnné</p><div class="ulist"><ul><li><p>Ty jsou definované jazykem</p></li><li><p>Nebo je dodává operační systém</p></li><li><p>Případně prohlížeč, ve kterém JavaScript běží.</p></li></ul></div></li></ul></div></div></section><section id="_funkce"><h2>Funkce</h2><div class="slide-content"><div class="paragraph"><p>Proměnné mají často podobu funkcí.</p></div>
<div class="ulist"><ul><li><p>Funkce je malý kousek programu a hodnot identifikovaný pomocí svého jména.</p></li><li><p>Funkci můžeme <em>volat</em> a předávat ji hodnoty, se kterými má pracovat.</p></li><li><p>Příkladem funkce je naše známá <code>console.log(&#8230;&#8203;)</code>.</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">// import funkce prompt
const prompt = require('prompt-sync')();

// Použití
const name = prompt('What is your name?');
console.log(`Hey there ${name}`);</code></pre></div></div></div></section><section id="_návratové_hodnoty"><h2>Návratové hodnoty</h2><div class="slide-content"><div class="paragraph"><p>Některé funkce maji <em>side efect</em> většinou ale vrací nějakou hodnotu</p></div>
<div class="ulist"><ul><li><p>Příkladem takové funkce je například</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(Math.max(2, 4));
// → 4</code></pre></div></div>
<div class="ulist"><ul><li><p>Funkce mohou být součástí výrazu</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">console.log(Math.min(2, 4) + 100);
// → 102</code></pre></div></div>
<div class="ulist"><ul><li><p>Více o funkcích za další části.</p></li></ul></div></div></section></section>
<section><section id="_běh_programu"><h2>Běh programu</h2><div class="slide-content"><div class="paragraph"><p>Pokud v programu máme více výrazů, vykonávají se jeden za druhým</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let theNumber = Number(prompt("Pick a number"));
let root = theNumber * theNumber;
console.log(`Your number is ${theNumber} and the square root of ${root}`);</code></pre></div></div><div class="ulist"><ul><li><p>Běh programu by se dal graficky znázornit jako šipka</p></li></ul></div><div class="imageblock" style=""><img src="media/controlflow-straight.svg" alt="controlflow straight"></div></div></section><section id="_podmíněné_vykonání"><h2>Podmíněné vykonání</h2><div class="slide-content"><div class="paragraph"><p>Pokud potřebuje určitou část kódu přeskočit, nebo na základě nějaké rozhodnu (podmínky) vybrat jednu ze dvou možných činností, říkáme tomu <em>conditional execution</em></p></div>
<div class="imageblock" style=""><img src="media/controlflow-if.svg" alt="controlflow if"></div>
<div class="ulist"><ul><li><p>Vytváří se pomocí klíčového slova <code>if</code>.</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">theNumber = Number(prompt("Pick a number"));
if (!Number.isNaN(a) &amp;&amp; a &gt; 0) {
 root = theNumber * theNumber;
 console.log(`Your number is ${a} and the square root of ${root}`);
}</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Pokud potřebuje použít jen jeden výraz, nepotřebujeme <code>{}</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">if (1 + 1 == 2) console.log("It's true");
// → It's true</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Pro alternativní větev používáme klíčové slovo <code>else</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">theNumber = Number(prompt("Pick a number"));
if (!Number.isNaN(theNumber)) {
 root = theNumber * theNumber;
 console.log(`Your number is ${a} and the square root of ${root}`);
} else {
 console.log("Hey. Why didn't you give me a number?");
}</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Pro více možností můžeme řetězit více <code>if/else</code> dohromady</p></li></ul></div>
<div class="imageblock" style=""><img src="media/controlflow-nested-if.svg" alt="controlflow nested if"></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let num = Number(prompt("Pick a number"));

if (num &lt; 10) {
 console.log("Small");
} else if (num &lt; 100) {
 console.log("Medium");
} else {
 console.log("Large");
}</code></pre></div></div></div></section><section id="_while_smyčky_s_podmínkou"><h2><code>while</code> smyčky s podmínkou</h2><div class="slide-content"><div class="paragraph"><p>Smyčky používáme v případě, že chceme provádět určitou část kódu opakovane dokud platí podmínka.</p></div>
<div class="imageblock" style=""><img src="media/controlflow-loop.svg" alt="controlflow loop"></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let number = 0;
while (number &lt;= 12) {
 console.log(number);
 number = number + 2;
}
// → 0
// → 2
//   … etcetera</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Pokud proměnnou deklarujeme před smyčkou a modifikuje během vykonání smyčky, zůstane v ní uložená poslední hodnota</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let result = 1;
let counter = 0;
while (counter &lt; 10) {
 result = result * 2;
 counter = counter + 1;
}
console.log(result);
// → 1024</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Předchozí smyčky meli podmínku na začátku, je možné ale vytvořit i smyčku s podmínkou na konci</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let yourName;
do {
 yourName = prompt("Who are you?");
} while (!yourName);
console.log(yourName);</code></pre></div></div></div></section><section id="_zarovnání_kódu"><h2>Zarovnání kódu</h2><div class="slide-content"><div class="paragraph"><p>Pro lepší přehlednost a čitelnost je dobré odsazovat bloky kódu</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">if (false != true) {
 console.log("That makes sense.");
 if (1 &lt; 2) {
   console.log("No surprise there.");
 }
}</code></pre></div></div></div></section><section id="_for_cyklus"><h2><code>for</code> cyklus</h2><div class="slide-content"><div class="paragraph"><p>Pokud je náš cyklu řízení hodnotou proměnné, je často lepší místo <code>while</code> použít <code>for</code></p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">for (let number = 0; number &lt;= 12; number = number + 2) {
 console.log(number);
}
// → 0
// → 2
//   … etcetera</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>příklad výpočtu hodnoty 2<sup>10</sup>.</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let result = 1;
for (let counter = 0; counter &lt; 10; counter = counter + 1) {
 result = result * 2;
}
console.log(result);
// → 1024</code></pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Pokud potřebujeme smyčku předčasně opustit, použijeme <code>break</code></p><div class="ulist"><ul><li><p><code>break</code> můžeme použít jak pro <code>for</code> tak pro <code>while</code> smyčky.</p></li></ul></div></li></ul></div>
<div class="listingblock"><div class="content"><pre>for (let current = 20; ; current = current + 1) {
 if (current % 7 == 0) {
   console.log(current);
   break;
 }
}
// → 21</pre></div></div></div></section><section><div class="slide-content"><div class="ulist"><ul><li><p>Pro zkrácení zápisu existuje několik speciálních operátorů, například <code>+=</code></p><div class="ulist"><ul><li><p>výraz: <code>counter = counter + 1;</code> lze přepsat na <code>counter += 1;</code></p></li><li><p>Alternativně existují: <code>-=</code>, <code>*=</code>, &#8230;&#8203;</p></li></ul></div></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">for (let number = 0; number &lt;= 12; number += 2) {
 console.log(number);
}</code></pre></div></div></div></section></section>
<section><section id="_switch_struktura"><h2><code>switch</code> struktura</h2><div class="slide-content"><div class="paragraph"><p>Mnohdy je potřeba napsat něco jako</p></div><div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">if (x == "value1") action1();
else if (x == "value2") action2();
else if (x == "value3") action3();
else defaultAction();</code></pre></div></div></div></section><section><div class="slide-content"><div class="paragraph"><p>JavaScript převzal strukturu z C/Java programovacího jazyku, která je "podivná" a <code>if/else</code> z předchozího příkladu vypadá nakonec lépe</p></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">switch (prompt("What is the weather like?")) {
 case "rainy":
   console.log("Remember to bring an umbrella.");
   break;
 case "sunny":
   console.log("Dress lightly.");
 case "cloudy":
   console.log("Go outside.");
   break;
 default:
   console.log("Unknown weather type!");
   break;
}</code></pre></div></div></div></section></section>
<section id="_komentáře"><h2>Komentáře</h2><div class="slide-content"><div class="paragraph"><p>Komenře jsou důležitou součástí každého programu, jejich primární cílem podpořit čitelnost a srozumitelnos kódu</p></div>
<div class="ulist"><ul><li><p>Jednořádkový komentář <code>//</code></p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">let accountBalance = calculateBalance(account);
// It's a green hollow where a river sings
accountBalance.adjust();
// Madly catching white tatters in the grass.
let report = new Report();
// Where the sun on the proud mountain rings:
addToReport(accountBalance, report);
// It's a little valley, foaming like light in a glass.
}</code></pre></div></div>
<div class="ulist"><ul><li><p>Víceřádkový komentář</p></li></ul></div>
<div class="listingblock"><div class="content"><pre class="highlightjs highlight"><code data-lang="JavaScript" class="language-JavaScript hljs" data-noescape="true">/*
 I first found this number scrawled on the back of an old
 notebook. Since then, it has often dropped by, showing up in
 phone numbers and the serial numbers of products that I've
 bought. It obviously likes me, so I've decided to keep it.
*/
const myNumber = 11213;</code></pre></div></div></div></section>
<section><section id="_summary"><h2>Summary</h2><div class="slide-content"><div class="paragraph"><p>Nyní víte, že program je sestaven z příkazů, které samy někdy obsahují více příkazů.
Příkazy obvykle obsahují výrazy, které samy o sobě lze sestavit z menších výrazů.</p></div><div class="paragraph"><p>Po sobě jdoucí výkazy získáte program, který se spouští shora dolů.
Přerušení v toku řízení můžete zavést pomocí podmíněných příkazů (<code>if</code>, <code>else</code> a <code>switch</code>) a smyček (<code>while</code>, <code>do</code> a <code>for</code>).</p></div></div></section><section><div class="slide-content"><div class="paragraph"><p>Přiřazení lze použít k ukládání částí dat pod názvem a jsou užitečné pro sledování stavu ve vašem programu.
Prostředí je sada přiřazení proměnných, které jsou definovány.
Systémy JavaScript vždy vkládají do vašeho prostředí řadu užitečných standardních proměnných.</p></div>
<div class="paragraph"><p>Funkce jsou speciální hodnoty, které zapouzdřují část programu. Můžete je vyvolat napsáním <code>functionName(argument1, argument2)</code>.
Takové volání funkce je výraz a může vytvářet hodnotu.</p></div></div></section></section>
<section><section id="_cvičení"><h2>Cvičení</h2></section><section id="_pyramida"><h2>Pyramida</h2><div class="slide-content"><div class="paragraph"><p>Pomocí smyčky vykreslete pyramidu.</p></div>
<div class="listingblock"><div class="content"><pre>   #
  ###
 #####
#######
#########</pre></div></div></div></section><section id="_fizzbuzz"><h2>FizzBuzz</h2><div class="slide-content"><div class="paragraph"><p>Vypisujte čísla od 1 do 100, ale</p></div>
<div class="ulist"><ul><li><p>pokud je číslo dělitelné 3, místo čísla vypište "Fizz"</p></li><li><p>pokud je číslo dělitelné 5, místo čísla vypište "Buzz"</p></li><li><p>a pokud je dělitelné 3 i 5, pak místo čísla vypište "FizzBuzz"</p></li></ul></div></div></section><section id="_šachovnice"><h2>Šachovnice</h2><div class="slide-content"><div class="paragraph"><p>Na Výstup vypište šachovnici 8×8, výstup by měl vypadat nějak takto</p></div>
<div class="listingblock"><div class="content"><pre>  | 1 | 2 | 3 | 4 | ...
---|---|---|---|---|
a |###|   |###|
---|---|---|---|---|
b |   |###|   |###|
---|---|---|---|---|
c |###|   |###|
---|---|---|---|---|
...</pre></div></div></div></section></section></div></div><script src="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/js/reveal.js"></script><script>Array.prototype.slice.call(document.querySelectorAll('.slides section')).forEach(function(slide) {
  if (slide.getAttribute('data-background-color')) return;
  // user needs to explicitly say he wants CSS color to override otherwise we might break custom css or theme (#226)
  if (!(slide.classList.contains('canvas') || slide.classList.contains('background'))) return;
  var bgColor = getComputedStyle(slide).backgroundColor;
  if (bgColor !== 'rgba(0, 0, 0, 0)' && bgColor !== 'transparent') {
    slide.setAttribute('data-background-color', bgColor);
    slide.style.backgroundColor = 'transparent';
  }
});

// More info about config & dependencies:
// - https://github.com/hakimel/reveal.js#configuration
// - https://github.com/hakimel/reveal.js#dependencies
Reveal.initialize({
  // Display presentation control arrows
  controls: true,
  // Help the user learn the controls by providing hints, for example by
  // bouncing the down arrow when they first encounter a vertical slide
  controlsTutorial: true,
  // Determines where controls appear, "edges" or "bottom-right"
  controlsLayout: 'bottom-right',
  // Visibility rule for backwards navigation arrows; "faded", "hidden"
  // or "visible"
  controlsBackArrows: 'faded',
  // Display a presentation progress bar
  progress: true,
  // Display the page number of the current slide
  slideNumber: false,
  // Control which views the slide number displays on
  showSlideNumber: 'all',
  // Add the current slide number to the URL hash so that reloading the
  // page/copying the URL will return you to the same slide
  hash: false,
  // Push each slide change to the browser history. Implies `hash: true`
  history: false,
  // Enable keyboard shortcuts for navigation
  keyboard: true,
  // Enable the slide overview mode
  overview: true,
  // Vertical centering of slides
  center: false,
  // Enables touch navigation on devices with touch input
  touch: true,
  // Loop the presentation
  loop: false,
  // Change the presentation direction to be RTL
  rtl: false,
  // See https://github.com/hakimel/reveal.js/#navigation-mode
  navigationMode: 'default',
  // Randomizes the order of slides each time the presentation loads
  shuffle: false,
  // Turns fragments on and off globally
  fragments: true,
  // Flags whether to include the current fragment in the URL,
  // so that reloading brings you to the same fragment position
  fragmentInURL: false,
  // Flags if the presentation is running in an embedded mode,
  // i.e. contained within a limited portion of the screen
  embedded: false,
  // Flags if we should show a help overlay when the questionmark
  // key is pressed
  help: true,
  // Flags if speaker notes should be visible to all viewers
  showNotes: false,
  // Global override for autolaying embedded media (video/audio/iframe)
  // - null: Media will only autoplay if data-autoplay is present
  // - true: All media will autoplay, regardless of individual setting
  // - false: No media will autoplay, regardless of individual setting
  autoPlayMedia: null,
  // Global override for preloading lazy-loaded iframes
  // - null: Iframes with data-src AND data-preload will be loaded when within
  //   the viewDistance, iframes with only data-src will be loaded when visible
  // - true: All iframes with data-src will be loaded when within the viewDistance
  // - false: All iframes with data-src will be loaded only when visible
  preloadIframes: null,
  // Number of milliseconds between automatically proceeding to the
  // next slide, disabled when set to 0, this value can be overwritten
  // by using a data-autoslide attribute on your slides
  autoSlide: 0,
  // Stop auto-sliding after user input
  autoSlideStoppable: true,
  // Use this method for navigation when auto-sliding
  autoSlideMethod: Reveal.navigateNext,
  // Specify the average time in seconds that you think you will spend
  // presenting each slide. This is used to show a pacing timer in the
  // speaker view
  defaultTiming: 120,
  // Specify the total time in seconds that is available to
  // present.  If this is set to a nonzero value, the pacing
  // timer will work out the time available for each slide,
  // instead of using the defaultTiming value
  totalTime: 0,
  // Specify the minimum amount of time you want to allot to
  // each slide, if using the totalTime calculation method.  If
  // the automated time allocation causes slide pacing to fall
  // below this threshold, then you will see an alert in the
  // speaker notes window
  minimumTimePerSlide: 0,
  // Enable slide navigation via mouse wheel
  mouseWheel: false,
  // Hide cursor if inactive
  hideInactiveCursor: true,
  // Time before the cursor is hidden (in ms)
  hideCursorTime: 5000,
  // Hides the address bar on mobile devices
  hideAddressBar: true,
  // Opens links in an iframe preview overlay
  // Add `data-preview-link` and `data-preview-link="false"` to customise each link
  // individually
  previewLinks: false,
  // Transition style (e.g., none, fade, slide, convex, concave, zoom)
  transition: 'slide',
  // Transition speed (e.g., default, fast, slow)
  transitionSpeed: 'default',
  // Transition style for full page slide backgrounds (e.g., none, fade, slide, convex, concave, zoom)
  backgroundTransition: 'fade',
  // Number of slides away from the current that are visible
  viewDistance: 3,
  // Number of slides away from the current that are visible on mobile
  // devices. It is advisable to set this to a lower number than
  // viewDistance in order to save resources.
  mobileViewDistance: 3,
  // Parallax background image (e.g., "'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg'")
  parallaxBackgroundImage: '',
  // Parallax background size in CSS syntax (e.g., "2100px 900px")
  parallaxBackgroundSize: '',
  // Number of pixels to move the parallax background per slide
  // - Calculated automatically unless specified
  // - Set to 0 to disable movement along an axis
  parallaxBackgroundHorizontal: null,
  parallaxBackgroundVertical: null,
  // The display mode that will be used to show slides
  display: 'block',

  // The "normal" size of the presentation, aspect ratio will be preserved
  // when the presentation is scaled to fit different resolutions. Can be
  // specified using percentage units.
  width: 1250,
  height: 700,

  // Factor of the display size that should remain empty around the content
  margin: 0.1,

  // Bounds for smallest/largest possible scale to apply to content
  minScale: 0.2,
  maxScale: 1.5,

  // PDF Export Options
  // Put each fragment on a separate page
  pdfSeparateFragments: true,
  // For slides that do not fit on a page, max number of pages
  pdfMaxPagesPerSlide: 1,

  // Optional libraries used to extend on reveal.js
  dependencies: [
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/zoom-js/zoom.js', async: true },
      { src: 'https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/plugin/notes/notes.js', async: true }
  ],

  

});</script><script>var dom = {};
dom.slides = document.querySelector('.reveal .slides');

function getRemainingHeight(element, slideElement, height) {
  height = height || 0;
  if (element) {
    var newHeight, oldHeight = element.style.height;
    // Change the .stretch element height to 0 in order find the height of all
    // the other elements
    element.style.height = '0px';
    // In Overview mode, the parent (.slide) height is set of 700px.
    // Restore it temporarily to its natural height.
    slideElement.style.height = 'auto';
    newHeight = height - slideElement.offsetHeight;
    // Restore the old height, just in case
    element.style.height = oldHeight + 'px';
    // Clear the parent (.slide) height. .removeProperty works in IE9+
    slideElement.style.removeProperty('height');
    return newHeight;
  }
  return height;
}

function layoutSlideContents(width, height) {
  // Handle sizing of elements with the 'stretch' class
  toArray(dom.slides.querySelectorAll('section .stretch')).forEach(function (element) {
    // Determine how much vertical space we can use
    var limit = 5; // hard limit
    var parent = element.parentNode;
    while (parent.nodeName !== 'SECTION' && limit > 0) {
      parent = parent.parentNode;
      limit--;
    }
    if (limit === 0) {
      // unable to find parent, aborting!
      return;
    }
    var remainingHeight = getRemainingHeight(element, parent, height);
    // Consider the aspect ratio of media elements
    if (/(img|video)/gi.test(element.nodeName)) {
      var nw = element.naturalWidth || element.videoWidth, nh = element.naturalHeight || element.videoHeight;
      var es = Math.min(width / nw, remainingHeight / nh);
      element.style.width = (nw * es) + 'px';
      element.style.height = (nh * es) + 'px';
    } else {
      element.style.width = width + 'px';
      element.style.height = remainingHeight + 'px';
    }
  });
}

function toArray(o) {
  return Array.prototype.slice.call(o);
}

Reveal.addEventListener('slidechanged', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('ready', function () {
  layoutSlideContents(1250, 700)
});
Reveal.addEventListener('resize', function () {
  layoutSlideContents(1250, 700)
});</script><link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/reveal.js@3.9.2/lib/css/monokai.css"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.18.1/highlight.min.js"></script>

<script>

/* highlightjs-line-numbers.js 2.6.0 | (C) 2018 Yauheni Pakala | MIT License | github.com/wcoder/highlightjs-line-numbers.js */
/* Edited by Hakim for reveal.js; removed async timeout */
!function(n,e){"use strict";function t(){var n=e.createElement("style");n.type="text/css",n.innerHTML=g(".{0}{border-collapse:collapse}.{0} td{padding:0}.{1}:before{content:attr({2})}",[v,L,b]),e.getElementsByTagName("head")[0].appendChild(n)}function r(t){"interactive"===e.readyState||"complete"===e.readyState?i(t):n.addEventListener("DOMContentLoaded",function(){i(t)})}function i(t){try{var r=e.querySelectorAll("code.hljs,code.nohighlight");for(var i in r)r.hasOwnProperty(i)&&l(r[i],t)}catch(o){n.console.error("LineNumbers error: ",o)}}function l(n,e){"object"==typeof n&&f(function(){n.innerHTML=s(n,e)})}function o(n,e){if("string"==typeof n){var t=document.createElement("code");return t.innerHTML=n,s(t,e)}}function s(n,e){e=e||{singleLine:!1};var t=e.singleLine?0:1;return c(n),a(n.innerHTML,t)}function a(n,e){var t=u(n);if(""===t[t.length-1].trim()&&t.pop(),t.length>e){for(var r="",i=0,l=t.length;i<l;i++)r+=g('<tr><td class="{0}"><div class="{1} {2}" {3}="{5}"></div></td><td class="{4}"><div class="{1}">{6}</div></td></tr>',[j,m,L,b,p,i+1,t[i].length>0?t[i]:" "]);return g('<table class="{0}">{1}</table>',[v,r])}return n}function c(n){var e=n.childNodes;for(var t in e)if(e.hasOwnProperty(t)){var r=e[t];h(r.textContent)>0&&(r.childNodes.length>0?c(r):d(r.parentNode))}}function d(n){var e=n.className;if(/hljs-/.test(e)){for(var t=u(n.innerHTML),r=0,i="";r<t.length;r++){var l=t[r].length>0?t[r]:" ";i+=g('<span class="{0}">{1}</span>\n',[e,l])}n.innerHTML=i.trim()}}function u(n){return 0===n.length?[]:n.split(y)}function h(n){return(n.trim().match(y)||[]).length}function f(e){e()}function g(n,e){return n.replace(/{(\d+)}/g,function(n,t){return e[t]?e[t]:n})}var v="hljs-ln",m="hljs-ln-line",p="hljs-ln-code",j="hljs-ln-numbers",L="hljs-ln-n",b="data-line-number",y=/\r\n|\r|\n/g;n.hljs?(n.hljs.initLineNumbersOnLoad=r,n.hljs.lineNumbersBlock=l,n.hljs.lineNumbersValue=o,t()):n.console.error("highlight.js not detected!")}(window,document);

/**
 * This reveal.js plugin is wrapper around the highlight.js
 * syntax highlighting library.
 */
(function( root, factory ) {
  if (typeof define === 'function' && define.amd) {
    root.RevealHighlight = factory();
  } else if( typeof exports === 'object' ) {
    module.exports = factory();
  } else {
    // Browser globals (root is window)
    root.RevealHighlight = factory();
  }
}( this, function() {

  // Function to perform a better "data-trim" on code snippets
  // Will slice an indentation amount on each line of the snippet (amount based on the line having the lowest indentation length)
  function betterTrim(snippetEl) {
    // Helper functions
    function trimLeft(val) {
      // Adapted from https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/String/Trim#Polyfill
      return val.replace(/^[\s\uFEFF\xA0]+/g, '');
    }
    function trimLineBreaks(input) {
      var lines = input.split('\n');

      // Trim line-breaks from the beginning
      for (var i = 0; i < lines.length; i++) {
        if (lines[i].trim() === '') {
          lines.splice(i--, 1);
        } else break;
      }

      // Trim line-breaks from the end
      for (var i = lines.length-1; i >= 0; i--) {
        if (lines[i].trim() === '') {
          lines.splice(i, 1);
        } else break;
      }

      return lines.join('\n');
    }

    // Main function for betterTrim()
    return (function(snippetEl) {
      var content = trimLineBreaks(snippetEl.innerHTML);
      var lines = content.split('\n');
      // Calculate the minimum amount to remove on each line start of the snippet (can be 0)
      var pad = lines.reduce(function(acc, line) {
        if (line.length > 0 && trimLeft(line).length > 0 && acc > line.length - trimLeft(line).length) {
          return line.length - trimLeft(line).length;
        }
        return acc;
      }, Number.POSITIVE_INFINITY);
      // Slice each line with this amount
      return lines.map(function(line, index) {
        return line.slice(pad);
      })
        .join('\n');
    })(snippetEl);
  }

  var RevealHighlight = {

    HIGHLIGHT_STEP_DELIMITER: '|',
    HIGHLIGHT_LINE_DELIMITER: ',',
    HIGHLIGHT_LINE_RANGE_DELIMITER: '-',

    init: function() {

      // Read the plugin config options and provide fallbacks
      var config = Reveal.getConfig().highlight || {};
      config.highlightOnLoad = typeof config.highlightOnLoad === 'boolean' ? config.highlightOnLoad : true;
      config.escapeHTML = typeof config.escapeHTML === 'boolean' ? config.escapeHTML : true;

      [].slice.call( document.querySelectorAll( '.reveal pre code' ) ).forEach( function( block ) {

        // Trim whitespace if the "data-trim" attribute is present
        if( block.hasAttribute( 'data-trim' ) && typeof block.innerHTML.trim === 'function' ) {
          block.innerHTML = betterTrim( block );
        }

        // Escape HTML tags unless the "data-noescape" attrbute is present
        if( config.escapeHTML && !block.hasAttribute( 'data-noescape' )) {
          block.innerHTML = block.innerHTML.replace( /</g,"&lt;").replace(/>/g, '&gt;' );
        }

        // Re-highlight when focus is lost (for contenteditable code)
        block.addEventListener( 'focusout', function( event ) {
          hljs.highlightBlock( event.currentTarget );
        }, false );

        if( config.highlightOnLoad ) {
          RevealHighlight.highlightBlock( block );
        }
      } );

    },

    /**
     * Highlights a code block. If the <code> node has the
     * 'data-line-numbers' attribute we also generate slide
     * numbers.
     *
     * If the block contains multiple line highlight steps,
     * we clone the block and create a fragment for each step.
     */
    highlightBlock: function( block ) {

      hljs.highlightBlock( block );

      // Don't generate line numbers for empty code blocks
      if( block.innerHTML.trim().length === 0 ) return;

      if( block.hasAttribute( 'data-line-numbers' ) ) {
        hljs.lineNumbersBlock( block, { singleLine: true } );

        // If there is at least one highlight step, generate
        // fragments
        var highlightSteps = RevealHighlight.deserializeHighlightSteps( block.getAttribute( 'data-line-numbers' ) );
        if( highlightSteps.length > 1 ) {

          // If the original code block has a fragment-index,
          // each clone should follow in an incremental sequence
          var fragmentIndex = parseInt( block.getAttribute( 'data-fragment-index' ), 10 );
          if( typeof fragmentIndex !== 'number' || isNaN( fragmentIndex ) ) {
            fragmentIndex = null;
          }

          // Generate fragments for all steps except the original block
          highlightSteps.slice(1).forEach( function( highlight ) {

            var fragmentBlock = block.cloneNode( true );
            fragmentBlock.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlight ] ) );
            fragmentBlock.classList.add( 'fragment' );
            block.parentNode.appendChild( fragmentBlock );
            RevealHighlight.highlightLines( fragmentBlock );

            if( typeof fragmentIndex === 'number' ) {
              fragmentBlock.setAttribute( 'data-fragment-index', fragmentIndex );
              fragmentIndex += 1;
            }
            else {
              fragmentBlock.removeAttribute( 'data-fragment-index' );
            }

          } );

          block.removeAttribute( 'data-fragment-index' )
          block.setAttribute( 'data-line-numbers', RevealHighlight.serializeHighlightSteps( [ highlightSteps[0] ] ) );

        }

        RevealHighlight.highlightLines( block );

      }

    },

    /**
     * Visually emphasize specific lines within a code block.
     * This only works on blocks with line numbering turned on.
     *
     * @param {HTMLElement} block a <code> block
     * @param {String} [linesToHighlight] The lines that should be
     * highlighted in this format:
     * "1" 		= highlights line 1
     * "2,5"	= highlights lines 2 & 5
     * "2,5-7"	= highlights lines 2, 5, 6 & 7
     */
    highlightLines: function( block, linesToHighlight ) {

      var highlightSteps = RevealHighlight.deserializeHighlightSteps( linesToHighlight || block.getAttribute( 'data-line-numbers' ) );

      if( highlightSteps.length ) {

        highlightSteps[0].forEach( function( highlight ) {

          var elementsToHighlight = [];

          // Highlight a range
          if( typeof highlight.end === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child(n+'+highlight.start+'):nth-child(-n+'+highlight.end+')' ) );
          }
          // Highlight a single line
          else if( typeof highlight.start === 'number' ) {
            elementsToHighlight = [].slice.call( block.querySelectorAll( 'table tr:nth-child('+highlight.start+')' ) );
          }

          if( elementsToHighlight.length ) {
            elementsToHighlight.forEach( function( lineElement ) {
              lineElement.classList.add( 'highlight-line' );
            } );

            block.classList.add( 'has-highlights' );
          }

        } );

      }

    },

    /**
     * Parses and formats a user-defined string of line
     * numbers to highlight.
     *
     * @example
     * RevealHighlight.deserializeHighlightSteps( '1,2|3,5-10' )
     * // [
     * //   [ { start: 1 }, { start: 2 } ],
     * //   [ { start: 3 }, { start: 5, end: 10 } ]
     * // ]
     */
    deserializeHighlightSteps: function( highlightSteps ) {

      // Remove whitespace
      highlightSteps = highlightSteps.replace( /\s/g, '' );

      // Divide up our line number groups
      highlightSteps = highlightSteps.split( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

      return highlightSteps.map( function( highlights ) {

        return highlights.split( RevealHighlight.HIGHLIGHT_LINE_DELIMITER ).map( function( highlight ) {

          // Parse valid line numbers
          if( /^[\d-]+$/.test( highlight ) ) {

            highlight = highlight.split( RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER );

            var lineStart = parseInt( highlight[0], 10 ),
              lineEnd = parseInt( highlight[1], 10 );

            if( isNaN( lineEnd ) ) {
              return {
                start: lineStart
              };
            }
            else {
              return {
                start: lineStart,
                end: lineEnd
              };
            }

          }
          // If no line numbers are provided, no code will be highlighted
          else {

            return {};

          }

        } );

      } );

    },

    /**
     * Serializes parsed line number data into a string so
     * that we can store it in the DOM.
     */
    serializeHighlightSteps: function( highlightSteps ) {

      return highlightSteps.map( function( highlights ) {

        return highlights.map( function( highlight ) {

          // Line range
          if( typeof highlight.end === 'number' ) {
            return highlight.start + RevealHighlight.HIGHLIGHT_LINE_RANGE_DELIMITER + highlight.end;
          }
          // Single line
          else if( typeof highlight.start === 'number' ) {
            return highlight.start;
          }
          // All lines
          else {
            return '';
          }

        } ).join( RevealHighlight.HIGHLIGHT_LINE_DELIMITER );

      } ).join( RevealHighlight.HIGHLIGHT_STEP_DELIMITER );

    }

  }

  Reveal.registerPlugin( 'highlight', RevealHighlight );

  return RevealHighlight;

}));
        
hljs.initHighlightingOnLoad();
</script></body></html>